"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _View = _interopRequireDefault(require("react-native-web/dist/exports/View"));

var _Text = _interopRequireDefault(require("react-native-web/dist/exports/Text"));

var _StyleSheet = _interopRequireDefault(require("react-native-web/dist/exports/StyleSheet"));

var _TouchableWithoutFeedback = _interopRequireDefault(require("react-native-web/dist/exports/TouchableWithoutFeedback"));

var _ViewPropTypes = _interopRequireDefault(require("react-native-web/dist/exports/ViewPropTypes"));

var _styles = require("quark-core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

var Checkbox = function Checkbox(_ref) {
  var style = _ref.style,
      children = _ref.children,
      content = _ref.content,
      onPress = _ref.onPress,
      unused = _objectWithoutProperties(_ref, ["style", "children", "content", "onPress"]);

  return React.createElement(_TouchableWithoutFeedback.default, {
    onPress: onPress
  }, React.createElement(_View.default, _extends({}, unused, {
    style: [styles.container, content ? styles.withContent : styles.withoutContent, children ? styles.active : styles.inactive, style]
  }), React.createElement(_Text.default, {
    style: children ? styles.activeText : styles.inactiveText
  }, content)));
};

var styles = _StyleSheet.default.create({
  container: {
    borderRadius: 3,
    borderWidth: 1,
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'
  },
  withContent: {
    paddingTop: 2 * _styles.baseDim,
    paddingBottom: 2 * _styles.baseDim,
    paddingLeft: 2 * _styles.baseDim,
    paddingRight: 2 * _styles.baseDim
  },
  withoutContent: {
    height: 9 * _styles.baseDim,
    width: 9 * _styles.baseDim
  },
  active: {
    backgroundColor: _styles.secondaryColor,
    borderColor: _styles.primaryColor
  },
  activeText: {
    color: _styles.primaryColor
  },
  inactive: {
    borderColor: _styles.grey3
  },
  inactiveText: {
    color: _styles.grey3
  }
});

var _default = Checkbox;
exports.default = _default;